﻿/*
 *************************************
 * File: ASbox.as
 * Version: 1.0
 * Author: Marcello Surdi
 * Web: http://www.marcellosurdi.name
 * E-mail: info@marcellosurdi.name
 * Created: 14/04/2008
 * Last update: 14/04/2008
 * License: http://creativecommons.org/licenses/by-sa/3.0/
 *************************************
 */

package  {
	import fl.transitions.easing.None;
	import fl.transitions.Tween;
	import fl.transitions.TweenEvent;
	import flash.display.Graphics;
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;

	public class ASbox  {
		private var imgAddr:String;
		private var imgLabel:String;
		private var oldSwfW:uint;
		private var oldSwfH:uint;
		private var swf:Stage;
		private var bg:Sprite = new Sprite();
		private var pr:Preloader = new Preloader();
		private var cn:Sprite = new Sprite();
		private var ld:Loader = new Loader();

		public function ASbox(btn:MovieClip,oldSwfW:uint,oldSwfH:uint):void  {
			imgAddr = btn.imgAddr;
			imgLabel = btn.imgLabel;
			this.oldSwfW = oldSwfW;
			this.oldSwfH = oldSwfH;

			swf = btn.stage;
			swf.addEventListener(Event.RESIZE,resizeBg);
			bg.x = (oldSwfW - swf.stageWidth) / 2;
			bg.y = (oldSwfH - swf.stageHeight) / 2;
			bg.graphics.beginFill(0x000000,.85);
			bg.graphics.drawRect(0,0,swf.stageWidth,swf.stageHeight);
			bg.graphics.endFill();
			swf.addChild(bg);

			loadImage();
		}

		private function resizeBg(e:Event):void  {
			bg.x = (oldSwfW - swf.stageWidth) / 2;
			bg.y = (oldSwfH - swf.stageHeight) / 2;
			bg.width = swf.stageWidth;
			bg.height = swf.stageHeight;
		}

		private function loadImage():void  {
			var addr:URLRequest = new URLRequest(imgAddr);
			var infoloader:LoaderInfo = ld.contentLoaderInfo;
			infoloader.addEventListener(IOErrorEvent.IO_ERROR,ioErrorHandler);
			infoloader.addEventListener(Event.OPEN,openHandler);
			infoloader.addEventListener(Event.COMPLETE,completeHandler);
			ld.load(addr);
		}

		private function ioErrorHandler(e:IOErrorEvent):void  {
			swf.removeChild(bg);
			trace(e.text);
		}

		private function openHandler(e:Event):void  {
			pr.x = (oldSwfW - pr.width) / 2;
			pr.y = (oldSwfH - pr.height) / 2;
			swf.addChild(pr);
		}

		private function completeHandler(e:Event):void  {
			swf.removeChild(pr);

			cn.graphics.beginFill(0xFFFFFF);
			var cnW:uint = e.target.width + 10;
			var cnH:uint = e.target.height + 25;
			cn.x = (oldSwfW - cnW) / 2;
			cn.y = (oldSwfH - cnH) / 2;
			cn.graphics.drawRect(0,0,cnW,cnH);
			cn.graphics.endFill();
			swf.addChild(cn);

			ld.x = 5;
			ld.y = 5;
			cn.addChild(ld);
			var tw:Tween = new Tween(ld,'alpha',None.easeIn,0,1,10,false);

			var cl:Closer = new Closer();
			cl.x = cnW - cl.width - 5;
			cl.y = cnH - 20;
			cl.buttonMode = true;
			cl.mouseChildren = false;
			cl.addEventListener(MouseEvent.CLICK,closeLightbox);
			cn.addChild(cl);

			if(imgLabel.length > 0)  {
				var tfFormat:TextFormat = new TextFormat();
				tfFormat.font = 'Arial';
				tfFormat.bold = true;
				tfFormat.size = 10;
				tfFormat.color = 0x999999;
				var tf:TextField = new TextField();
				tf.text = imgLabel.toUpperCase();
				tf.autoSize = TextFieldAutoSize.LEFT;
				tf.x = 5;
				tf.y = cnH - 20;
				tf.selectable = false;
				tf.setTextFormat(tfFormat);
				cn.addChild(tf);
			}
		}

		private function closeLightbox(e:MouseEvent):void  {
			swf.removeChild(cn);
			var tw:Tween = new Tween(bg,'alpha',None.easeIn,1,.25,10,false);
			tw.addEventListener(TweenEvent.MOTION_FINISH,function(e:TweenEvent)  { swf.removeChild(bg); });
		}
	}
}